﻿using Infragistics.Controls.Editors;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ComboEditor_DropDownWidht
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = CreateTable(3, 30).DefaultView;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column" + i, typeof(string)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column" + j] = "sfsfsdf" + r.Next(100000 * i);
                }

               d.Rows.Add(row);
            }
            return d;
        }

        private void XamComboEditor_Loaded(object sender, RoutedEventArgs e)
        {
            if((sender as XamComboEditor).Items.Count >=1)
            {
                Popup popup = Utilities.GetDescendantFromName(sender as DependencyObject, "Popup") as Popup;
                if (popup != null && popup.Child != null)
                    popup.Opened += new EventHandler(popup_Opened);
            }
        }

        private void popup_Opened(object sender, EventArgs e)
        {
            Grid myGrid = (sender as Popup).Child as Grid;
            if (myGrid != null && myGrid.Children != null) { 
            Border myBorder = Utilities.GetDescendantFromType(myGrid as DependencyObject, typeof(Border), false) as Border;
            if (myBorder != null)
            {
                myBorder.Width = double.NaN;
            }
        }
        }
    }
}
